routes/web.php
<?php
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;
use App\Http\Controllers\AccountController;
use App\Mail\newUserMail;
use Illuminate\Routing\Console\MiddlewareMakeCommand;
use Illuminate\Support\Facades\Mail;
use App\Account;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/florala', function () {
    return view('account.florala');
});
Route::get('/campaign', function () {
    return view('account.florala');
});



Route::get('login/{provider}', 'SocialController@redirect');
Route::get('login/{provider}/callback','SocialController@Callback');
// Route::get('/hello' , function(){
//     dd(Account::pluck('name'));
// });

Auth::routes();
Route::get('/email', function(){
    $event = 'udpmanage';
    Mail::to('udpmanage@gmail.com')->send(new newUserMail($event));
    return new newUserMail($event);
} );
Route::get('/' , 'AccountController@index')->middleware('auth');
Route::get('/notification' , 'PaymentController@notification')->middleware('auth');
Route::get('/restore' , 'PaymentController@restore')->middleware('auth');
Route::get('/forceDelete/{id}' , 'PaymentController@forceDelete')->middleware('auth');
Route::get('showAccount/{id}' , 'AccountController@showAccount')->middleware('auth');
Route::post('mail' , 'AccountController@mail');
Route::post('/restore-all', 'PaymentController@restoreAll')->name('payments.restore-all');
Route::get('/restore/{id}', 'PaymentController@restore')->name('payments.restore');
// Route::get('/payments/show/{id}', 'PaymentController@show')->name('payments.show');
Route::get('/chart', 'PaymentController@chart')->name('payments.chart');


Route::get('/payments/deletedpayments', 'PaymentController@deletedpayments')->name('payments.deletedpayments');

Route::get('/payments/reletedpayments/{id}' , 'PaymentController@reletedpayments' )->name('PaymentController.reletedpayments');
Route::get('/payments/create/{id}' , 'PaymentController@create' )->name('PaymentController.create');
Route::resource('/accounts' , 'AccountController')->middleware('auth');
Route::resource('/payments' , 'PaymentController')->middleware('auth');


Route::get('/home', 'HomeController@index')->name('home');

app/Payment.php
<?php

namespace App;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Notifications\Notifiable;

class Payment extends Model
{
    use SoftDeletes ,Notifiable;
    protected $dates = ['deleted_at'];
    protected $fillable = [
        'subject',
        'account_id',
        'payment_date',
        'payment_pending',
        'payment_recived',
        'pending_amount',
    ];   
    public function account()
    {
        return $this->belongsTo(Account::class);
    }
}

app/Http/Controllers/PaymentController.php
<?php

namespace App\Http\Controllers;

use App\Payment;
use App\Account;
use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;
use Illuminate\Support\Arr;
use Yajra\DataTables\Facades\DataTables;
use App\paymentCreated;
use Illuminate\Support\Facades\Notification;

class PaymentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {

        // dd(Payment::onlyTrashed()->get());
        $accounts = Payment::all();
        if ($request->ajax()) {
            $table =   DataTables::of($accounts)
                ->addIndexColumn()
                ->addColumn('action', function ($row) {
                    $btn = '<a class="btn btn-secondary mx-1" href = "payments/' . $row->id . '/edit" >edit  </a>';
                    $btn .= '<button class="btn btn-danger  mx-1 datadelete" value="' . $row->id . '">delete</button>';
                    return $btn;
                })
                ->addcolumn('account_name', function($row){
                    $account = Payment::find($row->id);
                    return $account->account->name;
                })
                ->addcolumn('payment_pending' ,function($row){
                    $date = '<span  class = "editable">'.$row->payment_recived.'</span>';
                    
                    return $date ;
                })
                // ->removeColumn('account_id')
                ->rawColumns(['action', 'checkbox' , 'payment_date' , 'payment_pending'])
                ->make(true);
            return $table;
        }
        return view('payment.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Payment $payment, $id)
    {
        $account  = Account::find($id);
        // dd($account);
        return view('payment.create', compact('account'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // dd($request->all(       ));
        // event(new paymentCreated($request->all()));
        $account = Account::find($request->account_id);
        // dd($request->all()); $account->payment_pending + $request->payment_pending;
        $payment_pending = $account->payment_pending + $request->payment_pending;
        if ($account->payment_recived <=  $payment_pending * .5) {
            $account->update([
                'payment_pending' => $account->payment_pending + $request->payment_pending,
                'status' => 'unpaid'
            ]);
        } else {
            // i    f($account->payment_recived <=  $payment_pending * .5){
            $account->update([
                'payment_pending' => $account->payment_pending + $request->payment_pending,
                'status' => 'halfpaid'
            ]);
        }
        $payment = new Payment();
        $payment->subject = $request->subject;
        // $payment->account_id = $request->account_id;
        $payment->payment_date = $request->payment_date;
        $payment->payment_pending = $request->payment_pending;
        $payment->payment_recived = $request->payment_recived;
        $payment->pending_amount = $request->pending_amount;
        $accountdetails = Account::find($request->account_id);
        $payment->account()->associate($accountdetails);
        $payment->save();

        event(new paymentCreated($payment->account , $payment));

        return redirect('payments');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Payment  $payment
     * @return \Illuminate\Http\Response
     */
    public function show(Payment $payment)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Payment  $payment
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $payment = Payment::find($id);
        return view('payment.form', compact('payment'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Payment  $payment
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request,  $payment)
    {
        // dd($request->all());
        $paymetdetails = [];
        $paymetdetails['subject'] = $request->subject;
        $paymetdetails['payment_date'] = $request->payment_date;
        $paymetdetails['payment_recived'] = $request->payment_recived;
        $paymetdetails['payment_pending'] = $request->payment_pending;
        $paymetdetails['pending_amount'] = $request->pending_amount;
        Payment::where('id', $payment)->update($paymetdetails);
        $accountdata = Account::find($request->account_id);
        $totalamountrecived = $accountdata->payment_recived + $request->payment_recived;
        $pendingamountpercenntage = $accountdata->payment_pending * .5;
        if ($pendingamountpercenntage > $totalamountrecived) {
            $accountdata->update(
                array(
                    'status' => 'unpaid',
                    'payment_recived' => $totalamountrecived
                )
            );
        } elseif ($accountdata->payment_pending == $totalamountrecived) {
            $accountdata->update(
                array(
                    'status' => 'fullpaid',
                    'payment_recived' => $totalamountrecived
                )
            );
        } else {
            $accountdata->update(
                array(
                    'status' => 'halfpaid',
                    'payment_recived' => $totalamountrecived
                )
            );
        }

        $payment = Payment::find($payment)->first();
        event(new paymentCreated($payment->account , $payment));

        return redirect('payments');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Payment  $payment
     * @return \Illuminate\Http\Response
     */
    public function destroy(Payment $payment)
    {
        // $payment->id;
        Payment::find($payment->id)->delete();
    }



    public function restore($id) 
    {
        // dd($id);
        Payment::where('id', $id)->withTrashed()->restore();

        return redirect()->route('payments.index');
        // ->withSuccess(__('User restored successfully.'));
    }

    public function forceDelete($id)
    {
        // dd($id);
        Payment::where('id', $id)->withTrashed()->forceDelete();

        return redirect()->route('payments.index');
        // ->withSuccess(__('User force deleted successfully.'));
    }



    public function restoreAll()
    {
        Payment::onlyTrashed()->restore();
        return redirect()->route('payments.index')->withSuccess(__('All users restored successfully.'));
    }


    public function deletedpayments()
    {
        $deletedpayments = Payment::onlyTrashed()->get();
        return view('payment.deletedpayments', compact('deletedpayments'));
    }



    public function chart()
    {

        $users  =DB::table('payments')->selectRaw('count(*) as count , account_id')->groupBy('account_id')->pluck('account_id');
        $companyname  =DB::table('accounts')->pluck('name');
        $payment_pending  =DB::table('accounts')->select('payment_pending')->pluck('payment_pending');
        $payment_recived  =DB::table('accounts')->select('payment_recived')->pluck('payment_recived');
        // $status  =DB::table('accounts')->selectRaw('count(*) as count , status')->groupBy('status')->pluck('status');
        $status  =DB::table('accounts')->selectRaw('count(*) as count , status')->groupBy('status')->get();

            $statusarr = [];
            $countarr = [];
            foreach ($status as $stat) {
                     array_push( $statusarr , $stat->status); 
                     array_push( $countarr , $stat->count); 
                }
// dd($countarr , $statusarr);
        // dump($payment_pending);
        return view('payment.chart', compact('companyname' , 'users' , 'payment_pending' , 'payment_recived' , 'statusarr' , 'countarr'));
    }


    public function notification()
    {
     
        dd('done');
    }

}

resources/views/payment/chart.blade.php
@extends('layouts.app')
@section('content')
    
<div class="container">
    <nav style="--bs-breadcrumb-divider: '>';" aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"> <a href=" {{ route('accounts.index') }} ">Account Details </a> </li>
            <li class="breadcrumb-item acti ve" aria-current="page">Charts</li>
        </ol>
    </nav>
    <h3 style="text-align: center;" class="m-3">Payment Recived And Payment Pending</h3>
        <div id="container1"></div>
        <h3 style="text-align: center ;">Payment Details Pie Chart</h3>
        <div id="piechart"></div>
    <h3 style="text-align: center;" class="m-3">Chart For Total Payments Created</h3>
    <div id="container"></div>
    </div>
{{-- @dd($statusarr) --}}
{{-- @dd($companyname , $payment_pending) --}}

<script src="https://code.highcharts.com/highcharts.js"></script>
<script type="text/javascript">
    var companyname =  <?php echo json_encode($companyname) ?>;
    var users =  <?php echo json_encode($users) ?>;
    var payment_pending =  <?php echo json_encode($payment_pending) ?>;
    var payment_recived =  <?php echo json_encode($payment_recived) ?>;
    var status =  <?php echo json_encode($statusarr) ?>;
    var count =  <?php echo json_encode($countarr) ?>;
    
    Highcharts.chart('container', {
        title: {
            text: ' Company`s Payment Count'
        },
        // subtitle: {
            //     text: 'Source: itsolutionstuff.com.com'
            // },
            xAxis: {
                categories: companyname
            },
            yAxis: {
            title: {
                text: 'Total Payments Open'
            }
        },
        legend: {
            layout: 'vertical',
            align: 'right',
            verticalAlign: 'middle'
        },
        plotOptions: {
            series: {
                allowPointSelect: true
            }
        },
        series: [{
            name: 'Count of Payments',
            data: users
        }],
        responsive: {
            rules: [{
                condition: {
                    maxWidth: 500
                },
                chartOptions: {
                    legend: {
                        layout: 'horizontal',
                        align: 'center',
                        verticalAlign: 'bottom'
                    }
                }
            }]
        }
});



Highcharts.chart('container1', {
    chart: {
        type: 'bar'
    },
    title: {
        text: 'Company VS payment recived  , payment pending'
    },
    subtitle: {
        text: 'Source: <a href="https://en.wikipedia.org/wiki/World_population">Wikipedia.org</a>'
    },
    xAxis: {
        categories: companyname,
        title: {
            text: null
        }
    },
    yAxis: {
        min: 0,
        title: {
            text: 'Rupees',
            align: 'high'
        },
        labels: {
            overflow: 'justify'
        }
    },
    tooltip: {
        valueSuffix: 'k'
    },
    plotOptions: {
        bar: {
            dataLabels: {
                enabled: true
            }
        }
    },
    legend: {
        layout: 'vertical',
        align: 'right',
        verticalAlign: 'top',
        x: -40,
        y: 80,
        floating: true,
        borderWidth: 1,
        backgroundColor:
        Highcharts.defaultOptions.legend.backgroundColor || '#FFFFFF',
        shadow: true
    },
    credits: {
        enabled: false
    },
    series: [{
        name: 'Payment Pending',
        data: payment_pending   
    }, {
        name: 'Payment Recived',
        data: payment_recived
    },  ]
});

Highcharts.chart('piechart', {
    chart: {
        plotBackgroundColor: null,
        plotBorderWidth: null,
        plotShadow: false,
        type: 'pie'
    },
    title: {
        text: 'Paid Halfpaid Unpaid chart Representation'
    },
    tooltip: {
        pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
    },
    accessibility: {
        point: {
            valueSuffix: '%'
        }
    },
    plotOptions: {
        pie: {
            allowPointSelect: true,
            cursor: 'pointer',
            dataLabels: {
                enabled: true,
                format: '<b>{point.name}</b>: {point.percentage:.1f} %'
            }
        }
    },
    series: [{
        name: 'Brands',
        colorByPoint: true,
        data: [{
            name: 'halfPiad',
            y: count[1],
             sliced: true,
            selected: true
        }, {
            name: 'Unpaid',
            y: count[0]
        }, {
            name: 'fullpaid',
            y: count[2]
        }]
    }]
});
</script>

@endsection

resources/views/payment/create.blade.php
@extends('layouts.app')
@section('content')



<script type="text/javascript" src="https://cdn.jsdelivr.net/jquery/latest/jquery.min.js"></script>
<script type="text/javascript" src="https://cdn.jsdelivr.net/momentjs/latest/moment.min.js"></script>
<script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.min.js"></script>
<link rel="stylesheet" type="text/css" href="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.css" />


<div class="container">
    <nav style="--bs-breadcrumb-divider: '>';" aria-label="breadcrumb">
        <ol class="breadcrumb">
          <li class="breadcrumb-item"> <a href=" {{route('payments.index')}} ">Payment Details </a> </li>
          <li class="breadcrumb-item acti ve" aria-current="page">Editing  Payment</li>
          {{-- <li class="breadcrumb-item active" aria-current="page">Subject Data</li>s --}}
        </ol>
      </nav>
      @php
         $ldate = date('Y-m-d H:i:s');
      @endphp
      {{-- @dd(); --}}
      

      {!! Form::open(['method' => 'POST' , 'route' => 'payments.store' , 'class' => 'form-horizontal']) !!}
    <div class="form-group{{ $errors->has('subject') ? ' has-error' : '' }}">
        {!! Form::label('subject', 'Subject') !!}
        {!! Form::text('subject', $account->name.' '.$ldate, ['class' => 'form-control', 'required' => 'required' , 'readonly']) !!}
        <small class="text-danger">{{ $errors->first('subject') }}</small>
    </div>
    <div class="form-group{{ $errors->has('account_id') ? ' has-error' : '' }}">
        {!! Form::label('account_id', 'Account ID') !!}
        {!! Form::text('account_id', $account->id, ['class' => 'form-control', 'required' => 'required', 'readonly']) !!}
        <small class="text-danger">{{ $errors->first('account_id') }}</small>
    </div>

    <div class="form-group{{ $errors->has('payment_date') ? ' has-error' : '' }}">
        {!! Form::label('payment_date', 'Payment Date') !!}
        {!! Form::text('payment_date', null, ['class' => 'form-control datetimepicker', 'required' => 'required']) !!}
        <small class="text-danger">{{ $errors->first('payment_date') }}</small>
    </div>
    <div class="form-group{{ $errors->has('payment_pending') ? ' has-error' : '' }}">
        {!! Form::label('payment_pending', 'PaymentPending') !!}
        {!! Form::number('payment_pending', 0, ['class' => 'form-control', 'required' => 'required' , ]) !!}
        <small class="text-danger">{{ $errors->first('payment_pending') }}</small>
    </div>
    <div class="form-group{{ $errors->has('payment_recived') ? ' has-error' : '' }}">
        {!! Form::label('payment_recived', 'Payment Recived') !!}
        {!! Form::number('payment_recived', null, ['class' => 'form-control', 'required' => 'required']) !!}
        <small class="text-danger">{{ $errors->first('payment_recived') }}</small>
    </div>
    <div class="form-group{{ $errors->has('pending_amount') ? ' has-error' : '' }}">
        {!! Form::label('pending_amount', 'Pending Amount') !!}
        {!! Form::number('pending_amount', $account->payment_pending, ['class' => 'form-control', 'required' => 'required' , 'readonly']) !!}
        <small class="text-danger">{{ $errors->first('pending_amount') }}</small>
    </div>
    <div class="btn-group pull-right my-3">
        {!! Form::reset('Reset', ['class' => 'btn btn-warning']) !!}
        {!! Form::submit('Add', ['class' => 'btn btn-Add']) !!}
    </div>
    {!! Form::close() !!}
</div>

<script>
    $(function() {
        $('input[name="payment_date"]').daterangepicker({
            singleDatePicker: true,
            showDropdowns: true,
            minYear: 1901,
            timePicker: true,
            locale: {
                format: 'M/DD/YYYY hh:mm A'
            },
            maxYear: parseInt(moment().format('YYYY'), 10)
        });

        $(document).on('keydown' , 'input[name="payment_recived"]' , function(){
            // console.log($(this).val());
            var payment_recived = $(this).val();
            var pending_amount = $('input[name="payment_pending"]').val() - payment_recived;
            $('input[name="pending_amount"]').val(pending_amount);
            
        });

    
    })
</script>


@endsection

resources/views/payment/deletedpayments.blade.php
@extends('layouts.app')
@section('content')



    <div class="container">
        <table class="table table-hover">
            <thead>

                <tr>
                    <th>id</th>
                    <th>Subject</th>
                    <th>Account Id </th>
                    <th>payment_date</th>
                    <th>payment_pending</th>
                    <th>payment_recived</th>
                    <th>pending_amount</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @foreach ($deletedpayments as $deletedpayment)
                <tr>
                    {{-- @dD($deletedpayment->id); --}}
                    <td> {{$deletedpayment->id}} </td>
                    <td> {{$deletedpayment->subject}} </td>
                    <td> {{$deletedpayment->account_id}} </td>
                    <td> {{$deletedpayment->payment_date}} </td>
                    <td> {{$deletedpayment->payment_pending}} </td>
                    <td> {{$deletedpayment->payment_recived}} </td>
                    <td> {{$deletedpayment->pending_amount}} </td>
                    <td>
                        <a class="btn btn-warning restore " href="/restore/{{$deletedpayment->id}}">Restore</a>
                        <a class="btn btn-danger" href="/forceDelete/{{$deletedpayment->id}}">Delete</a>
                    </td>
                    
                </tr>
                @endforeach
            </tbody>
        </table>
    </div>
    <script>
        $(function(){
            $(document).on('click' , '.restore' , function(){
                var restore_id  = $(this).val();
                var url = '/restore/'.concat(restore_id);
                console.log(url);
                $.ajax({
                    url :   url , 
                    type: 'GET', 
                    data: {
                        id : restore_id ,
                    },
                    success: function(data){
                        console.log('hello');
                    },
                });
            });
        });
    </script>
@endsection

resources/views/payment/form.blade.php
@extends('layouts.app')
@section('content')
    <script type="text/javascript" src="https://cdn.jsdelivr.net/jquery/latest/jquery.min.js"></script>
    <script type="text/javascript" src="https://cdn.jsdelivr.net/momentjs/latest/moment.min.js"></script>
    <script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.min.js"></script>
    <link rel="stylesheet" type="text/css" href="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.css" />


    <div class="container">
        <nav style="--bs-breadcrumb-divider: '>';" aria-label="breadcrumb">
            <ol class="breadcrumb">
              <li class="breadcrumb-item"> <a href=" {{route('payments.index')}} ">Payment Details </a> </li>
              <li class="breadcrumb-item acti ve" aria-current="page">Editing  Payment</li>
              {{-- <li class="breadcrumb-item active" aria-current="page">Subject Data</li>s --}}
            </ol>
          </nav>
    

        {!! Form::model($payment, [
            'route' => ['payments.update', $payment->id],
            'method' => 'PUT',
            'class' => 'form-horizontal',
        ]) !!}


        <div class="form-group{{ $errors->has('subject') ? ' has-error' : '' }}">
            {!! Form::label('subject', 'Subject') !!}
            {!! Form::text('subject', null, ['class' => 'form-control', 'required' => 'required']) !!}
            <small class="text-danger">{{ $errors->first('subject') }}</small>
        </div>
        <div class="form-group{{ $errors->has('account_id') ? ' has-error' : '' }}">
            {!! Form::label('account_id', 'Account ID') !!}
            {!! Form::text('account_id', null, ['class' => 'form-control', 'required' => 'required', 'readonly']) !!}
            <small class="text-danger">{{ $errors->first('account_id') }}</small>
        </div>

        <div class="form-group{{ $errors->has('payment_date') ? ' has-error' : '' }}">
            {!! Form::label('payment_date', 'Payment Date') !!}
            {!! Form::text('payment_date', null, ['class' => 'form-control datetimepicker', 'required' => 'required']) !!}
            <small class="text-danger">{{ $errors->first('payment_date') }}</small>
        </div>
        <div class="form-group{{ $errors->has('payment_pending') ? ' has-error' : '' }}">
            {!! Form::label('payment_pending', 'PaymentPending') !!}
            {!! Form::number('payment_pending', null, ['class' => 'form-control', 'required' => 'required' , 'readonly']) !!}
            <small class="text-danger">{{ $errors->first('payment_pending') }}</small>
        </div>
        <div class="form-group{{ $errors->has('payment_recived') ? ' has-error' : '' }}">
            {!! Form::label('payment_recived', 'Payment Recived') !!}
            {!! Form::number('payment_recived', 0, ['class' => 'form-control', 'required' => 'required']) !!}
            <small class="text-danger">{{ $errors->first('payment_recived') }}</small>
        </div>
        <div class="form-group{{ $errors->has('pending_amount') ? ' has-error' : '' }}">
            {!! Form::label('pending_amount', 'Pending Amount') !!}
            {!! Form::number('pending_amount', null, ['class' => 'form-control', 'required' => 'required' , 'readonly']) !!}
            <small class="text-danger">{{ $errors->first('pending_amount') }}</small>
        </div>
        <div class="btn-group pull-right my-3">
            {!! Form::reset('Reset', ['class' => 'btn btn-warning']) !!}
            {!! Form::submit('Add', ['class' => 'btn btn-Add']) !!}
        </div>
        {!! Form::close() !!}
    </div>

    <script>
        $(function() {
            $('input[name="payment_date"]').daterangepicker({
                singleDatePicker: true,
                showDropdowns: true,
                minYear: 1901,
                timePicker: true,
                locale: {
                    format: 'M/DD/YYYY hh:mm A'
                },
                maxYear: parseInt(moment().format('YYYY'), 10)
            });

            $(document).on('change' , 'input[name="payment_recived"]' , function(){
                // console.log($(this).val());
                var payment_recived = $(this).val();
                var pending_amount = $('input[name="pending_amount"]').val() - payment_recived;
                $('input[name="pending_amount"]').val(pending_amount);
                
            });

            
        })
    </script>
@endsection